"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from orq_ai_sdk import utils
from orq_ai_sdk.types import BaseModel
from orq_ai_sdk.utils import FieldMetadata, QueryParamMetadata
import pydantic
from typing import Any, Dict, List, Literal, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class GetEvalsRequestTypedDict(TypedDict):
    limit: NotRequired[float]
    r"""A limit on the number of objects to be returned. Limit can range between 1 and 50, and the default is 10"""
    starting_after: NotRequired[str]
    r"""A cursor for use in pagination. `starting_after` is an object ID that defines your place in the list. For instance, if you make a list request and receive 20 objects, ending with `01JJ1HDHN79XAS7A01WB3HYSDB`, your subsequent call can include `after=01JJ1HDHN79XAS7A01WB3HYSDB` in order to fetch the next page of the list."""
    ending_before: NotRequired[str]
    r"""A cursor for use in pagination. `ending_before` is an object ID that defines your place in the list. For instance, if you make a list request and receive 20 objects, starting with `01JJ1HDHN79XAS7A01WB3HYSDB`, your subsequent call can include `before=01JJ1HDHN79XAS7A01WB3HYSDB` in order to fetch the previous page of the list."""


class GetEvalsRequest(BaseModel):
    limit: Annotated[
        Optional[float],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = 10
    r"""A limit on the number of objects to be returned. Limit can range between 1 and 50, and the default is 10"""

    starting_after: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""A cursor for use in pagination. `starting_after` is an object ID that defines your place in the list. For instance, if you make a list request and receive 20 objects, ending with `01JJ1HDHN79XAS7A01WB3HYSDB`, your subsequent call can include `after=01JJ1HDHN79XAS7A01WB3HYSDB` in order to fetch the next page of the list."""

    ending_before: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""A cursor for use in pagination. `ending_before` is an object ID that defines your place in the list. For instance, if you make a list request and receive 20 objects, starting with `01JJ1HDHN79XAS7A01WB3HYSDB`, your subsequent call can include `before=01JJ1HDHN79XAS7A01WB3HYSDB` in order to fetch the previous page of the list."""


class GetEvalsEvalsResponseBodyData(BaseModel):
    message: str


class GetEvalsEvalsResponseBody(Exception):
    r"""Workspace ID is not found on the request"""

    data: GetEvalsEvalsResponseBodyData

    def __init__(self, data: GetEvalsEvalsResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(self.data, GetEvalsEvalsResponseBodyData)


GetEvalsObject = Literal["list"]

GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData72Type = Literal[
    "number"
]

GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONOperator = Literal[
    "eq", "ne", "gt", "gte", "lt", "lte"
]


class GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONNumberTypedDict(TypedDict):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData72Type
    value: float
    operator: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONOperator


class GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONNumber(BaseModel):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData72Type

    value: float

    operator: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONOperator


GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData7Type = Literal[
    "boolean"
]


class GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONBooleanTypedDict(TypedDict):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData7Type
    value: bool


class GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONBoolean(BaseModel):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData7Type

    value: bool


GetEvalsDataEvalsResponse200ApplicationJSONGuardrailConfigTypedDict = TypeAliasType(
    "GetEvalsDataEvalsResponse200ApplicationJSONGuardrailConfigTypedDict",
    Union[
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONBooleanTypedDict,
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONNumberTypedDict,
    ],
)


GetEvalsDataEvalsResponse200ApplicationJSONGuardrailConfig = TypeAliasType(
    "GetEvalsDataEvalsResponse200ApplicationJSONGuardrailConfig",
    Union[
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONBoolean,
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONNumber,
    ],
)


GetEvalsDataEvalsResponse200ApplicationJSONResponseBodyType = Literal["typescript_eval"]


class TypescriptTypedDict(TypedDict):
    id: str
    description: str
    code: str
    type: GetEvalsDataEvalsResponse200ApplicationJSONResponseBodyType
    key: str
    created: NotRequired[str]
    updated: NotRequired[str]
    guardrail_config: NotRequired[
        GetEvalsDataEvalsResponse200ApplicationJSONGuardrailConfigTypedDict
    ]


class Typescript(BaseModel):
    id: Annotated[str, pydantic.Field(alias="_id")]

    description: str

    code: str

    type: GetEvalsDataEvalsResponse200ApplicationJSONResponseBodyType

    key: str

    created: Optional[str] = "2025-06-23T12:22:10.982Z"

    updated: Optional[str] = "2025-06-23T12:22:10.982Z"

    guardrail_config: Optional[
        GetEvalsDataEvalsResponse200ApplicationJSONGuardrailConfig
    ] = None


GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData62Type = Literal[
    "number"
]

GetEvalsGuardrailConfigEvalsResponse200Operator = Literal[
    "eq", "ne", "gt", "gte", "lt", "lte"
]


class GetEvalsGuardrailConfigEvalsResponse200NumberTypedDict(TypedDict):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData62Type
    value: float
    operator: GetEvalsGuardrailConfigEvalsResponse200Operator


class GetEvalsGuardrailConfigEvalsResponse200Number(BaseModel):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData62Type

    value: float

    operator: GetEvalsGuardrailConfigEvalsResponse200Operator


GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData6Type = Literal[
    "boolean"
]


class GetEvalsGuardrailConfigEvalsResponse200BooleanTypedDict(TypedDict):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData6Type
    value: bool


class GetEvalsGuardrailConfigEvalsResponse200Boolean(BaseModel):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData6Type

    value: bool


GetEvalsDataEvalsResponse200GuardrailConfigTypedDict = TypeAliasType(
    "GetEvalsDataEvalsResponse200GuardrailConfigTypedDict",
    Union[
        GetEvalsGuardrailConfigEvalsResponse200BooleanTypedDict,
        GetEvalsGuardrailConfigEvalsResponse200NumberTypedDict,
    ],
)


GetEvalsDataEvalsResponse200GuardrailConfig = TypeAliasType(
    "GetEvalsDataEvalsResponse200GuardrailConfig",
    Union[
        GetEvalsGuardrailConfigEvalsResponse200Boolean,
        GetEvalsGuardrailConfigEvalsResponse200Number,
    ],
)


GetEvalsDataEvalsResponse200ApplicationJSONType = Literal["ragas"]

RagasMetric = Literal[
    "context_precision",
    "context_recall",
    "context_entities_recall",
    "harmfulness",
    "maliciousness",
    "coherence",
    "correctness",
    "conciseness",
    "response_relevancy",
    "faithfulness",
    "summarization",
    "noise_sensitivity",
]


class RagasTypedDict(TypedDict):
    id: str
    description: str
    type: GetEvalsDataEvalsResponse200ApplicationJSONType
    ragas_metric: RagasMetric
    key: str
    model: str
    created: NotRequired[str]
    updated: NotRequired[str]
    guardrail_config: NotRequired[GetEvalsDataEvalsResponse200GuardrailConfigTypedDict]


class Ragas(BaseModel):
    id: Annotated[str, pydantic.Field(alias="_id")]

    description: str

    type: GetEvalsDataEvalsResponse200ApplicationJSONType

    ragas_metric: RagasMetric

    key: str

    model: str

    created: Optional[str] = "2025-06-23T12:22:10.982Z"

    updated: Optional[str] = "2025-06-23T12:22:10.982Z"

    guardrail_config: Optional[GetEvalsDataEvalsResponse200GuardrailConfig] = None


GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData52Type = Literal[
    "number"
]

GetEvalsGuardrailConfigEvalsResponseOperator = Literal[
    "eq", "ne", "gt", "gte", "lt", "lte"
]


class GetEvalsGuardrailConfigEvalsResponseNumberTypedDict(TypedDict):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData52Type
    value: float
    operator: GetEvalsGuardrailConfigEvalsResponseOperator


class GetEvalsGuardrailConfigEvalsResponseNumber(BaseModel):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData52Type

    value: float

    operator: GetEvalsGuardrailConfigEvalsResponseOperator


GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData5Type = Literal[
    "boolean"
]


class GetEvalsGuardrailConfigEvalsResponseBooleanTypedDict(TypedDict):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData5Type
    value: bool


class GetEvalsGuardrailConfigEvalsResponseBoolean(BaseModel):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData5Type

    value: bool


GetEvalsDataEvalsResponseGuardrailConfigTypedDict = TypeAliasType(
    "GetEvalsDataEvalsResponseGuardrailConfigTypedDict",
    Union[
        GetEvalsGuardrailConfigEvalsResponseBooleanTypedDict,
        GetEvalsGuardrailConfigEvalsResponseNumberTypedDict,
    ],
)


GetEvalsDataEvalsResponseGuardrailConfig = TypeAliasType(
    "GetEvalsDataEvalsResponseGuardrailConfig",
    Union[
        GetEvalsGuardrailConfigEvalsResponseBoolean,
        GetEvalsGuardrailConfigEvalsResponseNumber,
    ],
)


GetEvalsDataEvalsResponse200Type = Literal["function_eval"]

GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData524Type = Literal[
    "levenshtein_distance"
]


class TwentyFourTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData524Type


class TwentyFour(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData524Type


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData523Type = Literal[
    "cosine_similarity"
]


class TwentyThreeTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData523Type


class TwentyThree(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData523Type


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData522Type = Literal[
    "meteor_score"
]


class TwentyTwoTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData522Type


class TwentyTwo(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData522Type


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData521Type = Literal[
    "rouge_n"
]


class TwentyOneTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData521Type


class TwentyOne(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData521Type


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData520Type = Literal[
    "bleu_score"
]


class TwentyTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData520Type


class Twenty(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData520Type


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData519Type = Literal[
    "bert_score"
]


class NineteenTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData519Type


class Nineteen(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData519Type


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData518Type = Literal[
    "moderations_google"
]


class EighteenTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData518Type


class Eighteen(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData518Type


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData517Type = Literal[
    "moderations_openai"
]


class SeventeenTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData517Type


class Seventeen(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData517Type


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData516Type = Literal[
    "is_valid_json"
]


class SixteenTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData516Type


class Sixteen(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData516Type


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData515Type = Literal[
    "regex"
]


class FifteenTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData515Type
    pattern: str


class Fifteen(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData515Type

    pattern: str


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData514Type = Literal[
    "one_line"
]


class FourteenTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData514Type


class Fourteen(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData514Type


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData513Type = Literal[
    "length_greater_than"
]


class ThirteenTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData513Type
    value: float


class Thirteen(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData513Type

    value: float


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData512Type = Literal[
    "length_between"
]


class TwelveTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData512Type
    min: float
    max: float


class Twelve(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData512Type

    min: float

    max: float


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData511Type = Literal[
    "length_less_than"
]


class ElevenTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData511Type
    value: float


class Eleven(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData511Type

    value: float


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData510Type = Literal[
    "exact_match"
]


class TenTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData510Type


class Ten(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData510Type


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData5Type = Literal[
    "ends_with"
]


class NineTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData5Type
    value: str


class Nine(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyData5Type

    value: str


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyDataType = Literal[
    "start_with"
]


class EightTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyDataType
    value: str


class Eight(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyDataType

    value: str


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyType = Literal[
    "contains_valid_link"
]


class SevenTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyType


class Seven(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONResponseBodyType


GetEvalsFunctionParamsEvalsResponse200ApplicationJSONType = Literal["contains_url"]


class SixTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONType


class Six(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200ApplicationJSONType


GetEvalsFunctionParamsEvalsResponse200Type = Literal["contains_email"]


class FiveTypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponse200Type


class Five(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponse200Type


GetEvalsFunctionParamsEvalsResponseType = Literal["contains_any"]


class FunctionParams4TypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsResponseType
    keywords: List[str]


class FunctionParams4(BaseModel):
    type: GetEvalsFunctionParamsEvalsResponseType

    keywords: List[str]


GetEvalsFunctionParamsEvalsType = Literal["contains_all"]


class FunctionParams3TypedDict(TypedDict):
    type: GetEvalsFunctionParamsEvalsType
    keywords: List[str]


class FunctionParams3(BaseModel):
    type: GetEvalsFunctionParamsEvalsType

    keywords: List[str]


GetEvalsFunctionParamsType = Literal["contains_none"]


class FunctionParams2TypedDict(TypedDict):
    type: GetEvalsFunctionParamsType
    keywords: List[str]


class FunctionParams2(BaseModel):
    type: GetEvalsFunctionParamsType

    keywords: List[str]


FunctionParamsType = Literal["contains"]


class FunctionParams1TypedDict(TypedDict):
    type: FunctionParamsType
    value: str


class FunctionParams1(BaseModel):
    type: FunctionParamsType

    value: str


DataFunctionParamsTypedDict = TypeAliasType(
    "DataFunctionParamsTypedDict",
    Union[
        NineteenTypedDict,
        TwentyOneTypedDict,
        TwentyFourTypedDict,
        TwentyThreeTypedDict,
        FiveTypedDict,
        SixTypedDict,
        TwentyTwoTypedDict,
        SixteenTypedDict,
        TwentyTypedDict,
        TenTypedDict,
        EighteenTypedDict,
        SevenTypedDict,
        SeventeenTypedDict,
        FourteenTypedDict,
        ThirteenTypedDict,
        FifteenTypedDict,
        ElevenTypedDict,
        FunctionParams2TypedDict,
        FunctionParams1TypedDict,
        NineTypedDict,
        EightTypedDict,
        FunctionParams4TypedDict,
        FunctionParams3TypedDict,
        TwelveTypedDict,
    ],
)


DataFunctionParams = TypeAliasType(
    "DataFunctionParams",
    Union[
        Nineteen,
        TwentyOne,
        TwentyFour,
        TwentyThree,
        Five,
        Six,
        TwentyTwo,
        Sixteen,
        Twenty,
        Ten,
        Eighteen,
        Seven,
        Seventeen,
        Fourteen,
        Thirteen,
        Fifteen,
        Eleven,
        FunctionParams2,
        FunctionParams1,
        Nine,
        Eight,
        FunctionParams4,
        FunctionParams3,
        Twelve,
    ],
)


class DataFunctionTypedDict(TypedDict):
    id: str
    description: str
    type: GetEvalsDataEvalsResponse200Type
    function_params: DataFunctionParamsTypedDict
    key: str
    created: NotRequired[str]
    updated: NotRequired[str]
    guardrail_config: NotRequired[GetEvalsDataEvalsResponseGuardrailConfigTypedDict]


class DataFunction(BaseModel):
    id: Annotated[str, pydantic.Field(alias="_id")]

    description: str

    type: GetEvalsDataEvalsResponse200Type

    function_params: DataFunctionParams

    key: str

    created: Optional[str] = "2025-06-23T12:22:10.982Z"

    updated: Optional[str] = "2025-06-23T12:22:10.982Z"

    guardrail_config: Optional[GetEvalsDataEvalsResponseGuardrailConfig] = None


GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataType = Literal[
    "number"
]

GetEvalsGuardrailConfigEvalsOperator = Literal["eq", "ne", "gt", "gte", "lt", "lte"]


class GetEvalsGuardrailConfigEvalsNumberTypedDict(TypedDict):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataType
    value: float
    operator: GetEvalsGuardrailConfigEvalsOperator


class GetEvalsGuardrailConfigEvalsNumber(BaseModel):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataType

    value: float

    operator: GetEvalsGuardrailConfigEvalsOperator


GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyType = Literal[
    "boolean"
]


class GetEvalsGuardrailConfigEvalsBooleanTypedDict(TypedDict):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyType
    value: bool


class GetEvalsGuardrailConfigEvalsBoolean(BaseModel):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyType

    value: bool


GetEvalsDataEvalsGuardrailConfigTypedDict = TypeAliasType(
    "GetEvalsDataEvalsGuardrailConfigTypedDict",
    Union[
        GetEvalsGuardrailConfigEvalsBooleanTypedDict,
        GetEvalsGuardrailConfigEvalsNumberTypedDict,
    ],
)


GetEvalsDataEvalsGuardrailConfig = TypeAliasType(
    "GetEvalsDataEvalsGuardrailConfig",
    Union[GetEvalsGuardrailConfigEvalsBoolean, GetEvalsGuardrailConfigEvalsNumber],
)


GetEvalsDataEvalsResponseType = Literal["python_eval"]


class DataPythonTypedDict(TypedDict):
    id: str
    description: str
    code: str
    type: GetEvalsDataEvalsResponseType
    key: str
    created: NotRequired[str]
    updated: NotRequired[str]
    guardrail_config: NotRequired[GetEvalsDataEvalsGuardrailConfigTypedDict]


class DataPython(BaseModel):
    id: Annotated[str, pydantic.Field(alias="_id")]

    description: str

    code: str

    type: GetEvalsDataEvalsResponseType

    key: str

    created: Optional[str] = "2025-06-23T12:22:10.982Z"

    updated: Optional[str] = "2025-06-23T12:22:10.982Z"

    guardrail_config: Optional[GetEvalsDataEvalsGuardrailConfig] = None


GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONType = Literal["number"]

GetEvalsGuardrailConfigOperator = Literal["eq", "ne", "gt", "gte", "lt", "lte"]


class GetEvalsGuardrailConfigNumberTypedDict(TypedDict):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONType
    value: float
    operator: GetEvalsGuardrailConfigOperator


class GetEvalsGuardrailConfigNumber(BaseModel):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONType

    value: float

    operator: GetEvalsGuardrailConfigOperator


GetEvalsGuardrailConfigEvalsResponse200Type = Literal["boolean"]


class GetEvalsGuardrailConfigBooleanTypedDict(TypedDict):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsResponse200Type
    value: bool


class GetEvalsGuardrailConfigBoolean(BaseModel):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsResponse200Type

    value: bool


GetEvalsDataGuardrailConfigTypedDict = TypeAliasType(
    "GetEvalsDataGuardrailConfigTypedDict",
    Union[
        GetEvalsGuardrailConfigBooleanTypedDict, GetEvalsGuardrailConfigNumberTypedDict
    ],
)


GetEvalsDataGuardrailConfig = TypeAliasType(
    "GetEvalsDataGuardrailConfig",
    Union[GetEvalsGuardrailConfigBoolean, GetEvalsGuardrailConfigNumber],
)


GetEvalsDataEvalsType = Literal["http_eval"]

DataMethod = Literal["GET", "POST"]


class DataHTTPTypedDict(TypedDict):
    id: str
    description: str
    type: GetEvalsDataEvalsType
    url: str
    method: DataMethod
    headers: Dict[str, str]
    payload: Dict[str, Any]
    key: str
    created: NotRequired[str]
    updated: NotRequired[str]
    guardrail_config: NotRequired[GetEvalsDataGuardrailConfigTypedDict]


class DataHTTP(BaseModel):
    id: Annotated[str, pydantic.Field(alias="_id")]

    description: str

    type: GetEvalsDataEvalsType

    url: str

    method: DataMethod

    headers: Dict[str, str]

    payload: Dict[str, Any]

    key: str

    created: Optional[str] = "2025-06-23T12:22:10.982Z"

    updated: Optional[str] = "2025-06-23T12:22:10.982Z"

    guardrail_config: Optional[GetEvalsDataGuardrailConfig] = None


GetEvalsGuardrailConfigEvalsResponseType = Literal["number"]

GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataOperator = (
    Literal["eq", "ne", "gt", "gte", "lt", "lte"]
)


class GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataNumberTypedDict(
    TypedDict
):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsResponseType
    value: float
    operator: (
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataOperator
    )


class GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataNumber(
    BaseModel
):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsResponseType

    value: float

    operator: (
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataOperator
    )


GetEvalsGuardrailConfigEvalsType = Literal["boolean"]


class GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataBooleanTypedDict(
    TypedDict
):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsType
    value: bool


class GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataBoolean(
    BaseModel
):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsType

    value: bool


DataGuardrailConfigTypedDict = TypeAliasType(
    "DataGuardrailConfigTypedDict",
    Union[
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataBooleanTypedDict,
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataNumberTypedDict,
    ],
)


DataGuardrailConfig = TypeAliasType(
    "DataGuardrailConfig",
    Union[
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataBoolean,
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyDataNumber,
    ],
)


GetEvalsDataType = Literal["json_schema"]


class DataJSONTypedDict(TypedDict):
    id: str
    description: str
    type: GetEvalsDataType
    schema_: str
    key: str
    created: NotRequired[str]
    updated: NotRequired[str]
    guardrail_config: NotRequired[DataGuardrailConfigTypedDict]


class DataJSON(BaseModel):
    id: Annotated[str, pydantic.Field(alias="_id")]

    description: str

    type: GetEvalsDataType

    schema_: Annotated[str, pydantic.Field(alias="schema")]

    key: str

    created: Optional[str] = "2025-06-23T12:22:10.982Z"

    updated: Optional[str] = "2025-06-23T12:22:10.982Z"

    guardrail_config: Optional[DataGuardrailConfig] = None


GetEvalsGuardrailConfigType = Literal["number"]

GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyOperator = Literal[
    "eq", "ne", "gt", "gte", "lt", "lte"
]


class GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyNumberTypedDict(
    TypedDict
):
    enabled: bool
    type: GetEvalsGuardrailConfigType
    value: float
    operator: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyOperator


class GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyNumber(
    BaseModel
):
    enabled: bool

    type: GetEvalsGuardrailConfigType

    value: float

    operator: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyOperator


GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData1Type = Literal[
    "boolean"
]


class GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyBooleanTypedDict(
    TypedDict
):
    enabled: bool
    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData1Type
    value: bool


class GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyBoolean(
    BaseModel
):
    enabled: bool

    type: GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyData1Type

    value: bool


GetEvalsDataEvalsResponse200ApplicationJSONResponseBodyGuardrailConfigTypedDict = TypeAliasType(
    "GetEvalsDataEvalsResponse200ApplicationJSONResponseBodyGuardrailConfigTypedDict",
    Union[
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyBooleanTypedDict,
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyNumberTypedDict,
    ],
)


GetEvalsDataEvalsResponse200ApplicationJSONResponseBodyGuardrailConfig = TypeAliasType(
    "GetEvalsDataEvalsResponse200ApplicationJSONResponseBodyGuardrailConfig",
    Union[
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyBoolean,
        GetEvalsGuardrailConfigEvalsResponse200ApplicationJSONResponseBodyNumber,
    ],
)


DataType = Literal["llm_eval"]


class DataLLMTypedDict(TypedDict):
    id: str
    description: str
    type: DataType
    prompt: str
    key: str
    model: str
    created: NotRequired[str]
    updated: NotRequired[str]
    guardrail_config: NotRequired[
        GetEvalsDataEvalsResponse200ApplicationJSONResponseBodyGuardrailConfigTypedDict
    ]


class DataLLM(BaseModel):
    id: Annotated[str, pydantic.Field(alias="_id")]

    description: str

    type: DataType

    prompt: str

    key: str

    model: str

    created: Optional[str] = "2025-06-23T12:22:10.982Z"

    updated: Optional[str] = "2025-06-23T12:22:10.982Z"

    guardrail_config: Optional[
        GetEvalsDataEvalsResponse200ApplicationJSONResponseBodyGuardrailConfig
    ] = None


GetEvalsDataTypedDict = TypeAliasType(
    "GetEvalsDataTypedDict",
    Union[
        DataJSONTypedDict,
        DataPythonTypedDict,
        DataFunctionTypedDict,
        TypescriptTypedDict,
        DataLLMTypedDict,
        RagasTypedDict,
        DataHTTPTypedDict,
    ],
)


GetEvalsData = TypeAliasType(
    "GetEvalsData",
    Union[DataJSON, DataPython, DataFunction, Typescript, DataLLM, Ragas, DataHTTP],
)


class GetEvalsResponseBodyTypedDict(TypedDict):
    r"""Returns a list of evals"""

    object: GetEvalsObject
    data: List[GetEvalsDataTypedDict]
    has_more: bool


class GetEvalsResponseBody(BaseModel):
    r"""Returns a list of evals"""

    object: GetEvalsObject

    data: List[GetEvalsData]

    has_more: bool
