"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from orq_ai_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from orq_ai_sdk.utils import FieldMetadata, PathParamMetadata, parse_datetime
import pydantic
from pydantic import model_serializer
from typing import Any, Dict, List, Literal, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class RetrieveDatapointRequestTypedDict(TypedDict):
    dataset_id: str
    datapoint_id: str


class RetrieveDatapointRequest(BaseModel):
    dataset_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]

    datapoint_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]


RetrieveDatapointMessagesDatasetsResponse200ApplicationJSONRole = Literal["tool"]
r"""The role of the messages author, in this case tool."""

RetrieveDatapointMessagesDatasetsResponseContentTypedDict = TypeAliasType(
    "RetrieveDatapointMessagesDatasetsResponseContentTypedDict", Union[str, List[str]]
)
r"""The contents of the tool message."""


RetrieveDatapointMessagesDatasetsResponseContent = TypeAliasType(
    "RetrieveDatapointMessagesDatasetsResponseContent", Union[str, List[str]]
)
r"""The contents of the tool message."""


class RetrieveDatapointMessagesToolMessageTypedDict(TypedDict):
    role: RetrieveDatapointMessagesDatasetsResponse200ApplicationJSONRole
    r"""The role of the messages author, in this case tool."""
    content: RetrieveDatapointMessagesDatasetsResponseContentTypedDict
    r"""The contents of the tool message."""
    tool_call_id: str
    r"""Tool call that this message is responding to."""


class RetrieveDatapointMessagesToolMessage(BaseModel):
    role: RetrieveDatapointMessagesDatasetsResponse200ApplicationJSONRole
    r"""The role of the messages author, in this case tool."""

    content: RetrieveDatapointMessagesDatasetsResponseContent
    r"""The contents of the tool message."""

    tool_call_id: str
    r"""Tool call that this message is responding to."""


RetrieveDatapoint2DatasetsResponse200ApplicationJSONResponseBodyType = Literal[
    "refusal"
]
r"""The type of the content part."""


class RetrieveDatapoint2RefusalContentPartTypedDict(TypedDict):
    type: RetrieveDatapoint2DatasetsResponse200ApplicationJSONResponseBodyType
    r"""The type of the content part."""
    refusal: str
    r"""The refusal message generated by the model."""


class RetrieveDatapoint2RefusalContentPart(BaseModel):
    type: RetrieveDatapoint2DatasetsResponse200ApplicationJSONResponseBodyType
    r"""The type of the content part."""

    refusal: str
    r"""The refusal message generated by the model."""


RetrieveDatapoint2DatasetsResponse200ApplicationJSONType = Literal["text"]
r"""The type of the content part."""


class RetrieveDatapoint2TextContentPartTypedDict(TypedDict):
    type: RetrieveDatapoint2DatasetsResponse200ApplicationJSONType
    r"""The type of the content part."""
    text: str
    r"""The text content."""


class RetrieveDatapoint2TextContentPart(BaseModel):
    type: RetrieveDatapoint2DatasetsResponse200ApplicationJSONType
    r"""The type of the content part."""

    text: str
    r"""The text content."""


RetrieveDatapointContentDatasets2TypedDict = TypeAliasType(
    "RetrieveDatapointContentDatasets2TypedDict",
    Union[
        RetrieveDatapoint2TextContentPartTypedDict,
        RetrieveDatapoint2RefusalContentPartTypedDict,
    ],
)


RetrieveDatapointContentDatasets2 = TypeAliasType(
    "RetrieveDatapointContentDatasets2",
    Union[RetrieveDatapoint2TextContentPart, RetrieveDatapoint2RefusalContentPart],
)


RetrieveDatapointMessagesDatasetsContentTypedDict = TypeAliasType(
    "RetrieveDatapointMessagesDatasetsContentTypedDict",
    Union[str, List[RetrieveDatapointContentDatasets2TypedDict]],
)
r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""


RetrieveDatapointMessagesDatasetsContent = TypeAliasType(
    "RetrieveDatapointMessagesDatasetsContent",
    Union[str, List[RetrieveDatapointContentDatasets2]],
)
r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""


RetrieveDatapointMessagesDatasetsResponse200Role = Literal["assistant"]
r"""The role of the messages author, in this case `assistant`."""


class RetrieveDatapointMessagesAudioTypedDict(TypedDict):
    r"""Data about a previous audio response from the model."""

    id: str
    r"""Unique identifier for a previous audio response from the model."""


class RetrieveDatapointMessagesAudio(BaseModel):
    r"""Data about a previous audio response from the model."""

    id: str
    r"""Unique identifier for a previous audio response from the model."""


RetrieveDatapointMessagesType = Literal["function"]
r"""The type of the tool. Currently, only `function` is supported."""


class RetrieveDatapointMessagesFunctionTypedDict(TypedDict):
    name: NotRequired[str]
    r"""The name of the function to call."""
    arguments: NotRequired[str]
    r"""The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function."""


class RetrieveDatapointMessagesFunction(BaseModel):
    name: Optional[str] = None
    r"""The name of the function to call."""

    arguments: Optional[str] = None
    r"""The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function."""


class RetrieveDatapointMessagesToolCallsTypedDict(TypedDict):
    id: str
    r"""The ID of the tool call."""
    type: RetrieveDatapointMessagesType
    r"""The type of the tool. Currently, only `function` is supported."""
    function: RetrieveDatapointMessagesFunctionTypedDict


class RetrieveDatapointMessagesToolCalls(BaseModel):
    id: str
    r"""The ID of the tool call."""

    type: RetrieveDatapointMessagesType
    r"""The type of the tool. Currently, only `function` is supported."""

    function: RetrieveDatapointMessagesFunction


class RetrieveDatapointMessagesAssistantMessageTypedDict(TypedDict):
    role: RetrieveDatapointMessagesDatasetsResponse200Role
    r"""The role of the messages author, in this case `assistant`."""
    content: NotRequired[Nullable[RetrieveDatapointMessagesDatasetsContentTypedDict]]
    r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""
    refusal: NotRequired[Nullable[str]]
    r"""The refusal message by the assistant."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""
    audio: NotRequired[Nullable[RetrieveDatapointMessagesAudioTypedDict]]
    r"""Data about a previous audio response from the model."""
    tool_calls: NotRequired[List[RetrieveDatapointMessagesToolCallsTypedDict]]
    r"""The tool calls generated by the model, such as function calls."""
    reasoning: NotRequired[str]
    r"""Internal thought process of the model"""
    reasoning_signature: NotRequired[str]
    r"""The signature holds a cryptographic token which verifies that the thinking block was generated by the model, and is verified when thinking is part of a multiturn conversation. This value should not be modified and should always be sent to the API when the reasoning is redacted. Currently only supported by `Anthropic`."""
    redacted_reasoning: NotRequired[str]
    r"""Occasionally the model's internal reasoning will be flagged by the safety systems of the provider. When this occurs, the provider will encrypt the reasoning. These redacted reasoning is decrypted when passed back to the API, allowing the model to continue its response without losing context."""


class RetrieveDatapointMessagesAssistantMessage(BaseModel):
    role: RetrieveDatapointMessagesDatasetsResponse200Role
    r"""The role of the messages author, in this case `assistant`."""

    content: OptionalNullable[RetrieveDatapointMessagesDatasetsContent] = UNSET
    r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""

    refusal: OptionalNullable[str] = UNSET
    r"""The refusal message by the assistant."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""

    audio: OptionalNullable[RetrieveDatapointMessagesAudio] = UNSET
    r"""Data about a previous audio response from the model."""

    tool_calls: Optional[List[RetrieveDatapointMessagesToolCalls]] = None
    r"""The tool calls generated by the model, such as function calls."""

    reasoning: Optional[str] = None
    r"""Internal thought process of the model"""

    reasoning_signature: Optional[str] = None
    r"""The signature holds a cryptographic token which verifies that the thinking block was generated by the model, and is verified when thinking is part of a multiturn conversation. This value should not be modified and should always be sent to the API when the reasoning is redacted. Currently only supported by `Anthropic`."""

    redacted_reasoning: Optional[str] = None
    r"""Occasionally the model's internal reasoning will be flagged by the safety systems of the provider. When this occurs, the provider will encrypt the reasoning. These redacted reasoning is decrypted when passed back to the API, allowing the model to continue its response without losing context."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "content",
            "refusal",
            "name",
            "audio",
            "tool_calls",
            "reasoning",
            "reasoning_signature",
            "redacted_reasoning",
        ]
        nullable_fields = ["content", "refusal", "audio"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


RetrieveDatapointMessagesDatasetsResponseRole = Literal["user"]
r"""The role of the messages author, in this case `user`."""

RetrieveDatapoint2DatasetsResponse200Type = Literal["file"]
r"""The type of the content part. Always `file`."""


class RetrieveDatapoint2FileTypedDict(TypedDict):
    file_data: str
    r"""The base64 encoded file data, used when passing the file to the model as a string."""
    filename: str
    r"""The name of the file, used when passing the file to the model as a string."""


class RetrieveDatapoint2File(BaseModel):
    file_data: str
    r"""The base64 encoded file data, used when passing the file to the model as a string."""

    filename: str
    r"""The name of the file, used when passing the file to the model as a string."""


class RetrieveDatapoint24TypedDict(TypedDict):
    type: RetrieveDatapoint2DatasetsResponse200Type
    r"""The type of the content part. Always `file`."""
    file: RetrieveDatapoint2FileTypedDict


class RetrieveDatapoint24(BaseModel):
    type: RetrieveDatapoint2DatasetsResponse200Type
    r"""The type of the content part. Always `file`."""

    file: RetrieveDatapoint2File


RetrieveDatapoint2DatasetsResponseType = Literal["input_audio"]

RetrieveDatapoint2Format = Literal["mp3", "wav"]
r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class RetrieveDatapoint2InputAudioTypedDict(TypedDict):
    data: str
    r"""Base64 encoded audio data."""
    format_: RetrieveDatapoint2Format
    r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class RetrieveDatapoint2InputAudio(BaseModel):
    data: str
    r"""Base64 encoded audio data."""

    format_: Annotated[RetrieveDatapoint2Format, pydantic.Field(alias="format")]
    r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class RetrieveDatapoint23TypedDict(TypedDict):
    type: RetrieveDatapoint2DatasetsResponseType
    input_audio: RetrieveDatapoint2InputAudioTypedDict


class RetrieveDatapoint23(BaseModel):
    type: RetrieveDatapoint2DatasetsResponseType

    input_audio: RetrieveDatapoint2InputAudio


RetrieveDatapoint2DatasetsType = Literal["image_url"]

RetrieveDatapoint2Detail = Literal["low", "high", "auto"]
r"""Specifies the detail level of the image."""


class RetrieveDatapoint2ImageURLTypedDict(TypedDict):
    url: str
    r"""Either a URL of the image or the base64 encoded image data."""
    detail: NotRequired[RetrieveDatapoint2Detail]
    r"""Specifies the detail level of the image."""


class RetrieveDatapoint2ImageURL(BaseModel):
    url: str
    r"""Either a URL of the image or the base64 encoded image data."""

    detail: Optional[RetrieveDatapoint2Detail] = None
    r"""Specifies the detail level of the image."""


class RetrieveDatapoint22TypedDict(TypedDict):
    type: RetrieveDatapoint2DatasetsType
    image_url: RetrieveDatapoint2ImageURLTypedDict


class RetrieveDatapoint22(BaseModel):
    type: RetrieveDatapoint2DatasetsType

    image_url: RetrieveDatapoint2ImageURL


RetrieveDatapoint2Type = Literal["text"]


class RetrieveDatapoint21TypedDict(TypedDict):
    type: RetrieveDatapoint2Type
    text: str


class RetrieveDatapoint21(BaseModel):
    type: RetrieveDatapoint2Type

    text: str


RetrieveDatapointContent2TypedDict = TypeAliasType(
    "RetrieveDatapointContent2TypedDict",
    Union[
        RetrieveDatapoint21TypedDict,
        RetrieveDatapoint22TypedDict,
        RetrieveDatapoint23TypedDict,
        RetrieveDatapoint24TypedDict,
    ],
)


RetrieveDatapointContent2 = TypeAliasType(
    "RetrieveDatapointContent2",
    Union[
        RetrieveDatapoint21,
        RetrieveDatapoint22,
        RetrieveDatapoint23,
        RetrieveDatapoint24,
    ],
)


RetrieveDatapointMessagesContentTypedDict = TypeAliasType(
    "RetrieveDatapointMessagesContentTypedDict",
    Union[str, List[RetrieveDatapointContent2TypedDict]],
)
r"""The contents of the user message."""


RetrieveDatapointMessagesContent = TypeAliasType(
    "RetrieveDatapointMessagesContent", Union[str, List[RetrieveDatapointContent2]]
)
r"""The contents of the user message."""


class RetrieveDatapointMessagesUserMessageTypedDict(TypedDict):
    role: RetrieveDatapointMessagesDatasetsResponseRole
    r"""The role of the messages author, in this case `user`."""
    content: RetrieveDatapointMessagesContentTypedDict
    r"""The contents of the user message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class RetrieveDatapointMessagesUserMessage(BaseModel):
    role: RetrieveDatapointMessagesDatasetsResponseRole
    r"""The role of the messages author, in this case `user`."""

    content: RetrieveDatapointMessagesContent
    r"""The contents of the user message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


RetrieveDatapointMessagesDatasetsRole = Literal["system"]
r"""The role of the messages author, in this case `system`."""


class RetrieveDatapointMessagesSystemMessageTypedDict(TypedDict):
    role: RetrieveDatapointMessagesDatasetsRole
    r"""The role of the messages author, in this case `system`."""
    content: str
    r"""The contents of the system message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class RetrieveDatapointMessagesSystemMessage(BaseModel):
    role: RetrieveDatapointMessagesDatasetsRole
    r"""The role of the messages author, in this case `system`."""

    content: str
    r"""The contents of the system message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


RetrieveDatapointMessagesRole = Literal["developer"]
r"""The role of the messages author, in this case  `developer`."""


class RetrieveDatapointMessagesDeveloperMessageTypedDict(TypedDict):
    role: RetrieveDatapointMessagesRole
    r"""The role of the messages author, in this case  `developer`."""
    content: str
    r"""The contents of the developer message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class RetrieveDatapointMessagesDeveloperMessage(BaseModel):
    role: RetrieveDatapointMessagesRole
    r"""The role of the messages author, in this case  `developer`."""

    content: str
    r"""The contents of the developer message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


RetrieveDatapointMessagesTypedDict = TypeAliasType(
    "RetrieveDatapointMessagesTypedDict",
    Union[
        RetrieveDatapointMessagesDeveloperMessageTypedDict,
        RetrieveDatapointMessagesSystemMessageTypedDict,
        RetrieveDatapointMessagesUserMessageTypedDict,
        RetrieveDatapointMessagesToolMessageTypedDict,
        RetrieveDatapointMessagesAssistantMessageTypedDict,
    ],
)


RetrieveDatapointMessages = TypeAliasType(
    "RetrieveDatapointMessages",
    Union[
        RetrieveDatapointMessagesDeveloperMessage,
        RetrieveDatapointMessagesSystemMessage,
        RetrieveDatapointMessagesUserMessage,
        RetrieveDatapointMessagesToolMessage,
        RetrieveDatapointMessagesAssistantMessage,
    ],
)


class RetrieveDatapointResponseBodyTypedDict(TypedDict):
    r"""Datapoint retrieved."""

    id: str
    r"""The unique identifier of the dataset item"""
    workspace_id: str
    r"""The unique identifier of the workspace it belongs to"""
    dataset_id: str
    r"""The unique identifier of the dataset"""
    inputs: NotRequired[Dict[str, Any]]
    r"""The inputs of the dataset. Key value pairs where the key is the input name and the value is the input value. Nested objects are not supported."""
    messages: NotRequired[List[RetrieveDatapointMessagesTypedDict]]
    r"""A list of messages comprising the conversation so far"""
    expected_output: NotRequired[str]
    created_by_id: NotRequired[str]
    r"""The unique identifier of the user who created the dataset"""
    updated_by_id: NotRequired[str]
    r"""The unique identifier of the user who last updated the dataset"""
    created: NotRequired[datetime]
    r"""The date and time the resource was created"""
    updated: NotRequired[datetime]
    r"""The date and time the resource was last updated"""


class RetrieveDatapointResponseBody(BaseModel):
    r"""Datapoint retrieved."""

    id: Annotated[str, pydantic.Field(alias="_id")]
    r"""The unique identifier of the dataset item"""

    workspace_id: str
    r"""The unique identifier of the workspace it belongs to"""

    dataset_id: str
    r"""The unique identifier of the dataset"""

    inputs: Optional[Dict[str, Any]] = None
    r"""The inputs of the dataset. Key value pairs where the key is the input name and the value is the input value. Nested objects are not supported."""

    messages: Optional[List[RetrieveDatapointMessages]] = None
    r"""A list of messages comprising the conversation so far"""

    expected_output: Optional[str] = None

    created_by_id: Optional[str] = None
    r"""The unique identifier of the user who created the dataset"""

    updated_by_id: Optional[str] = None
    r"""The unique identifier of the user who last updated the dataset"""

    created: Optional[datetime] = None
    r"""The date and time the resource was created"""

    updated: Optional[datetime] = parse_datetime("2025-06-23T12:22:08.975Z")
    r"""The date and time the resource was last updated"""
